package com.its.op.service.its.facility;

import com.its.op.dao.repository.its.facility.TbFcltSubjRepository;
import com.its.op.dto.its.common.NewIdLongDto;
import com.its.op.dto.its.facility.TbFcltSubjDto;
import com.its.op.entity.its.facility.TbFcltSubj;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Optional;

@Slf4j
@RequiredArgsConstructor
@Service
public class TbFcltSubjService {

    private final TbFcltSubjRepository repo;

    // 데이터 1건 조회, 없으면 exception
    private TbFcltSubj requireOne(Long id) throws NoSuchElementException {
        Optional<TbFcltSubj> info = this.repo.findById(id);
        if (info.isPresent()) {
            return info.get();
        }
        else {
            throw new NoSuchElementException("데이터가 존재하지 않습니다: " + id);
        }
    }

    // 전체 데이터 조회
    @Transactional(readOnly = true)
    public List<TbFcltSubjDto> findAll() {
        List<TbFcltSubjDto> result = new ArrayList<>();
        List<TbFcltSubj> data = this.repo.findAll();
        for (TbFcltSubj entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

    // 데이터 1건 조회(기존 데이터가 반드시 존재해야 함)
    @Transactional(readOnly = true)
    public TbFcltSubjDto findById(Long id) {
        TbFcltSubj entity = requireOne(id);
        return entity.toDto();
    }

    // 데이터 변경 또는 생성-개별(데이터가 존재하면 업데이트 없으면 신규로 생성)
    @Transactional
    public TbFcltSubjDto mergeInfo(TbFcltSubjDto.TbFcltSubjUpdReq req) {
        TbFcltSubj obj = req.toEntity();
        this.repo.save(obj);
        return obj.toDto();
    }

    // 정보 삭제-개별, 데이터 존재하지 않으면 Exception
    @Transactional
    public TbFcltSubjDto deleteById(Long id) {
        TbFcltSubj entity = requireOne(id);
        this.repo.deleteById(id);
        return entity.toDto();
    }

    @Transactional(readOnly = true)
    public NewIdLongDto getNewNmbr() {
        Long newId = this.repo.getNewNmbr();
        return NewIdLongDto.builder().newId(newId).build();
    }

    @Transactional(readOnly = true)
    public NewIdLongDto getNewSubjId(String fcltType) {
        Long newId = this.repo.getNewSubjId(fcltType);
        return NewIdLongDto.builder().newId(newId).build();
    }

    @Transactional(readOnly = true)
    public List<TbFcltSubjDto> findAllByFcltType(String fcltType) {
        List<TbFcltSubjDto> result = new ArrayList<>();
        List<TbFcltSubj> data = this.repo.findAllByFcltType(fcltType);
        for (TbFcltSubj entity : data) {
            result.add(entity.toDto());
        }
        return result;
    }

}
